// ListSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ListSample.h"

#include "gtlist32.h" //this was created using classwizard (Classes from OLETypeLib)
#include "gtlist.h"

#include "ListSampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListSampleDlg dialog

CListSampleDlg::CListSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CListSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CListSampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CListSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListSampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CListSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CListSampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListSampleDlg message handlers

BOOL CListSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	InitializeList();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CListSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CListSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CListSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//this function is just a helper
CGTList1* CListSampleDlg::GetList(long ID)
{
	CGTList1* pCtrl = (CGTList1*)(GetDlgItem(ID));
	return pCtrl;
}

//this function initializes the list
void CListSampleDlg::InitializeList()
{
	CGTList1* pList = GetList();

	//we create these variables to pass to the create function
	VARIANT vError;
	VARIANT vText;

	VariantInit(&vError);
	VariantInit(&vText);

	vError.vt = VT_ERROR; //this states to use the default

	//Add Columns to the list
	vText.vt = VT_BSTR;
	vText.bstrVal = CString("Column0").AllocSysString();
	_DColumnDefs(pList->GetColumnDefs(vError)).Add(vError, vError, vText);
	VariantClear(&vText); //deallocate the string

	vText.vt = VT_BSTR;
	vText.bstrVal = CString("Column1").AllocSysString();
	_DColumnDefs(pList->GetColumnDefs(vError)).Add(vError, vError, vText);
	VariantClear(&vText); //deallocate the string

	// Add Items to the list
	vText.vt = VT_BSTR;
	vText.bstrVal = CString("Item0Col0").AllocSysString();
	_DListItems(pList->GetListItems(vError)).Add(vError, vError, vText, vError, vError, vError);
	VariantClear(&vText); //deallocate the string

	vText.vt = VT_BSTR;
	vText.bstrVal = CString("Item1Col0").AllocSysString();
	_DListItems(pList->GetListItems(vError)).Add(vError, vError, vText, vError, vError, vError);
	VariantClear(&vText); //deallocate the string

	vText.vt = VT_BSTR;
	vText.bstrVal = CString("Item2Col0").AllocSysString();
	_DListItems(pList->GetListItems(vError)).Add(vError, vError, vText, vError, vError, vError);
	VariantClear(&vText); //deallocate the string

	vText.vt = VT_BSTR;
	vText.bstrVal = CString("Item3Col0").AllocSysString();
	_DListItems(pList->GetListItems(vError)).Add(vError, vError, vText, vError, vError, vError);
	VariantClear(&vText); //deallocate the string

	//Set the Text in the second column for eah item
	VARIANT vListItemIndex;
	VariantInit(&vListItemIndex);
	vListItemIndex.vt = VT_I4;

	VARIANT vSubItemIndex;
	VariantInit(&vSubItemIndex);
	vSubItemIndex.vt = VT_I4;
	vSubItemIndex.lVal = 1; //we are going to set column #1's text

	vListItemIndex.lVal = 0;
	vText.vt = VT_BSTR;
	vText.bstrVal = CString("Item0Col0").AllocSysString();
	_DSubItem(_DListItem(pList->GetListItems(vListItemIndex)).GetSubItems(vSubItemIndex)).SetText("Item0Col1");
	VariantClear(&vText); //deallocate the string

	vListItemIndex.lVal = 1;
	vText.vt = VT_BSTR;
	vText.bstrVal = CString("Item0Col0").AllocSysString();
	_DSubItem(_DListItem(pList->GetListItems(vListItemIndex)).GetSubItems(vSubItemIndex)).SetText("Item0Col1");
	VariantClear(&vText); //deallocate the string

	vListItemIndex.lVal = 2;
	vText.vt = VT_BSTR;
	vText.bstrVal = CString("Item0Col0").AllocSysString();
	_DSubItem(_DListItem(pList->GetListItems(vListItemIndex)).GetSubItems(vSubItemIndex)).SetText("Item0Col1");
	VariantClear(&vText); //deallocate the string

	vListItemIndex.lVal = 3;
	vText.vt = VT_BSTR;
	vText.bstrVal = CString("Item0Col0").AllocSysString();
	_DSubItem(_DListItem(pList->GetListItems(vListItemIndex)).GetSubItems(vSubItemIndex)).SetText("Item0Col1");
	VariantClear(&vText); //deallocate the string

}
